unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Grids, Unit2, Process;

type

  { TFormFibonacciFolge }

  TFormFibonacciFolge = class(TForm)
    BitBtnCollatzProblem: TBitBtn;
    BitBtnWikipediaCollatzProblem: TBitBtn;
    BitBtnWikipediaGoldenerSchnitt: TBitBtn;
    BitBtnGoldenerSchnitt: TBitBtn;
    BitBtnPrimZahlen: TBitBtn;
    BitBtnBerechnungPrimZahlen: TBitBtn;
    BitBtnStop: TBitBtn;
    BitBtnWikipediaFibonacciFolge: TBitBtn;
    BitBtnBerechnungFibonacci: TBitBtn;
    EditCollatzProblem: TEdit;
    LabelSignal: TLabel;
    LabelZeit: TLabel;
    LabelStartZeit: TLabel;
    LabelDatum: TLabel;
    ListBoxCP: TListBox;
    ListBoxGS: TListBox;
    ListBoxZahl: TListBox;
    PanelColatzProblem: TPanel;
    PanelGoldenerSchnitt: TPanel;
    PanelSiebDesEratosthenes: TPanel;
    PanelFibonacciFolge: TPanel;
    PanelAnzahl: TPanel;
    RadioButtonSehrLangsam: TRadioButton;
    RadioButtonLangsam: TRadioButton;
    RadioButtonSchnell: TRadioButton;
    SpeedButtonLizenz: TSpeedButton;
    StringGridPrimZahlen: TStringGrid;
    Timer: TTimer;
    TimerZeit: TTimer;

    procedure BitBtnBerechnungPrimZahlenClick(Sender: TObject);
    procedure BitBtnCollatzProblemClick(Sender: TObject);
    procedure BitBtnGoldenerSchnittClick(Sender: TObject);
    procedure BitBtnPrimZahlenClick(Sender: TObject);
    procedure BitBtnStopClick(Sender: TObject);
    procedure BitBtnBerechnungFibonacciClick(Sender: TObject);
    procedure BitBtnWikipediaCollatzProblemClick(Sender: TObject);
    procedure BitBtnWikipediaFibonacciFolgeClick(Sender: TObject);
    procedure BitBtnWikipediaGoldenerSchnittClick(Sender: TObject);
    procedure ButtonSignalResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButtonLizenzClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure TimerZeitTimer(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

procedure AufrufInternet;                                                       // Internet

const ErstStart:         Boolean=True;
      SignalEinAus:      Boolean=False;                                         // Blinker
      Phi:               Double=1.6180;
      PhiHalbe:          Double=0.3090;
var
  FormFibonacciFolge:    TFormFibonacciFolge;

  FiSi:                  Char;                                                  // F=Fibonacci; G=Gold: S=Sieb
  Zahl1, Zahl2, Summe:   int64;
  Zaehler:               Integer;

  a,b:                   Double;                                                // Achtung! Double verwenden

  Zeile,Spalte,PrimZahl: Integer;
  PrimZahlenFeld:        Array [0..350] Of Boolean;                             // Anzahl Feldelemente
  LetzteZahl:            Integer;

  ZeichenKette,Kette:    String;

implementation

{ TFormFibonacciFolge }

(*--------------------------- StartBedingungen -------------------------------*)

procedure TFormFibonacciFolge.FormCreate(Sender: TObject);
begin
  If ErstStart Then
    Begin
      ErstStart:=False;
      LabelDatum.Caption:='Datum: '+FormatDateTime('dd.mm.yyyy',Date);
      LabelStartZeit.Caption:='StartZeit: '+FormatDateTime('hh.mm.ss',Time);
    End;

  ListBoxZahl.Clear;
  ZeichenKette:='Das Programm ist Felix R. Paturi';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='für sein Buch';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='"Die letzten Rätsel der Wissenschaft"';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='und den Autoren Brody & Brody';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='für ihr Buch "Die 7 größten Rätsel';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='der Wissenschaft" gewidmet.';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='Beide Bücher haben meine Sicht auf';
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:='die Welt seht stark beeinflusst!';
  ListBoxZahl.Items.Add(ZeichenKette);

  ListBoxGS.Clear;                                                             // ListBoxGoldenerSchnitt
  ListBoxGS.Items.Add('***   Göttliche Teilung   ***');
  ListBoxGS.Items.Add('');
//  Phi:=(1+Sqrt(5))/2;
  ZeichenKette:=FormatFloat('#.000',Phi);
  ListBoxGS.Items.Add('Phi = (1+Sqrt(5))/2) = '+ZeichenKette+'...');

  ListBoxCP.Clear;
  ListBoxCP.Items.Add('*** (3n + 1)-Vermutung ***');
  ListBoxCP.Items.Add(' ');
  ListBoxCP.Items.Add('- Beginne mit natürlicher Zahl n.');
  ListBoxCP.Items.Add('- n gerade     --> n / 2,');
  ListBoxCP.Items.Add('- n ungerade --> 3n + 1.');
  ListBoxCP.Items.Add('- so lange, bis n = 1');
    EditCollatzProblem.Text:='   Gib natuerliche Zahl n ein!';

  PrimZahl:=2;                                                                  // Sieb-Grid füllen
  For Zeile:=0 To StringGridPrimZahlen.RowCount-1 Do
    For Spalte:=0 To StringGridPrimZahlen.ColCount-1 Do
      Begin
        StringGridPrimZahlen.Cells[Spalte,Zeile]:=IntToStr(PrimZahl);
        PrimzahlenFeld[PrimZahl-2]:=True;
        Inc(PrimZahl);
      End;
  LetzteZahl:=PrimZahl-1;
//  ShowMessage('LetzteZahl: '+IntToStr(LetzteZahl));
end;

(*--------------------------- Zeit -------------------------------------------*)

procedure TFormFibonacciFolge.TimerZeitTimer(Sender: TObject);
begin
  LabelZeit.Caption:='Zeit: '+FormatDateTime('hh.mm.ss',Time);
end;
(*--------------------------- Anzeige Hilfe / Lizenz -------------------------*)

procedure TFormFibonacciFolge.SpeedButtonLizenzClick(Sender: TObject);
begin
  FormInfo.ShowModal;                                                           // Anzeige Formular
end;

(*--------------------------- Aufruf Internet --------------------------------*)

procedure AufrufInternet;
  var AProcess: TProcess;
begin
  AProcess := TProcess.Create(nil);

  AProcess.CommandLine := ZeichenKette;
//  AProcess.Options := AProcess.Options + [poWaitOnExit];                      // Möglichkeit, dass Programm soll nicht weiterläuft
  AProcess.Execute;                                                             // eigentlicher Aufruf

  AProcess.Free;
end;

(*--------------------------- Timer-Sart -------------------------------------*)

procedure TFormFibonacciFolge.ButtonSignalResize(Sender: TObject);              // einfach eine gewählt! und dann "keine" eingetragen!
begin
  FormCreate(Sender);
  PanelAnzahl.Caption:='Anzahl Berechnungen: ';
  If RadioButtonSehrLangsam.Checked Then Timer.Interval:=1500                   // sehr langsam
                                    Else
    If RadioButtonLangsam.Checked Then Timer.Interval:=500                      // langsam
                                  Else Timer.Interval:=1;                       // schnell
  Timer.Enabled:=True; BitBtnStop.Enabled:=True; LabelSignal.Enabled:=True;     // Timer ein
End;

(*--------------------------- Aufruf FireFox mit Fibonacci -------------------*)

procedure TFormFibonacciFolge.BitBtnWikipediaFibonacciFolgeClick(Sender: TObject);
begin
  ZeichenKette:='/usr/bin/firefox http://de.wikipedia.org/wiki/Fibonacci-Folge';  // für Pardus
//  ZeichenKette:='vollst.Pfad IE http://de.wikipedia.org/wiki/Fibonacci-Folge';  // für Windows
  AufrufInternet;
end;

(*--------------------------- Aufruf FireFox mit Goldener Schnitt ------------*)

procedure TFormFibonacciFolge.BitBtnWikipediaGoldenerSchnittClick(Sender: TObject);
begin
  ZeichenKette:='/usr/bin/firefox http://de.wikipedia.org/wiki/Goldener_Schnitt';  // für Pardus
//  ZeichenKette:='vollst. Pfad IE http://de.wikipedia.org/wiki/Goldener_Schnitt'; // für Windows
  AufrufInternet;
end;

(*--------------------------- Aufruf FireFox mit Collatz-Problem ----------------*)

procedure TFormFibonacciFolge.BitBtnWikipediaCollatzProblemClick(Sender: TObject);
begin
  ZeichenKette:='/usr/bin/firefox http://de.wikipedia.org/wiki/Collatz-Problem';  // für Pardus
//  ZeichenKette:='vollst. Pfad IE http://de.wikipedia.org/wiki/Collatz-Problem'; // für Windows
  AufrufInternet;
end;

(*--------------------------- Aufruf FireFox mit Eratosthenes ----------------*)

procedure TFormFibonacciFolge.BitBtnPrimZahlenClick(Sender: TObject);
begin
  ZeichenKette:='/usr/bin/firefox http://de.wikipedia.org/wiki/Sieb_des_Eratosthenes';  // für Pardus
//  ZeichenKette:='vollst. Pfad IE http://de.wikipedia.org/wiki/Sieb_des_Eratosthenes'; // für Windows
  AufrufInternet;
end;

(*--------------------------- Timer ------------------------------------------*)

procedure TFormFibonacciFolge.TimerTimer(Sender: TObject);

var i,j,k: Integer;

begin
  If FiSi='F' Then
    Begin                                                                       // Fibonacci-Folge
      Summe:=Zahl1+Zahl2;                                                       // Formel

      ZeichenKette:=FormatFloat('###,###,###,##0',Summe);
      For i:=1 To Length(Zeichenkette) Do If ZeichenKette[i]=',' Then ZeichenKette[i]:='.';
      While Length(ZeichenKette)<>30 Do ZeichenKette:= ' '+ZeichenKette;
      If Summe=13 Then ZeichenKette:=ZeichenKette+'                ==> das ist meine Lieblingszahl'
                  Else
      If Summe=317811 Then ZeichenKette:=ZeichenKette+'            ==> Das Licht legt im Vakuum in einer Sekunde 299.792,458 Kilometer zurück.'
                      Else
      If Summe=102334155 Then ZeichenKette:=ZeichenKette+'         ==> Das menschliche Genom besteht aus etwa 100.000 Genen.'
                         Else
      If Summe=4807526976 Then ZeichenKette:=ZeichenKette+'        ==> Die ersten geologisch nachgewiesenen Spuren von Leben sind etwa 4 Milliarden Jahre alt.'
                        Else
      If Summe=12586269025 Then ZeichenKette:=ZeichenKette+'       ==> Das Universum ist etwa 13,7 Milliarden Jahre alt - es könnte aber auch wesentlich älter sein!'
                         Else
      If Summe=53316291173 Then ZeichenKette:=ZeichenKette+'       ==> Ein menschlicher Körper besteht aus etwa 60 Milliarden Zellen.'
                         Else
      If Summe=86267571272 Then ZeichenKette:=ZeichenKette+'       ==> Das menschliche Gehirn besteht aus etwa 100 Milliarden Zellen.';

      ListBoxZahl.Items.Add(ZeichenKette);
      Zahl1:=Zahl2; Zahl2:=Summe; Zaehler:=Succ(Zaehler);
      PanelAnzahl.Caption:='Anzahl Berechnungen: '+IntToStr(Zaehler);
      if Zaehler=82 Then BitBtnStopClick(Sender);                               // Abbruch Timer
    end       Else

    If FiSi='G' Then
      Begin                                                                     // GoldeneSchnitt
        a:=a+0.5;


        b:=b+PhiHalbe;                                                          // Formel
        b:=b+0.0005; b:=b*1000; b:=int(b); b:=b/1000;                           // Rundung

        ZeichenKette:=FormatFloat('##0.0',a);
        While Length(ZeichenKette)<>5 Do ZeichenKette:= ' '+ZeichenKette;
        Kette:='a='+ZeichenKette;

        ZeichenKette:=FormatFloat('##0.000',b);
        While Length(ZeichenKette)<>7 Do ZeichenKette:= ' '+ZeichenKette;
        Kette:=Kette+'   ==>   b='+ZeichenKette;

        ListBoxGS.Items.Add(Kette);

        Zaehler:=Succ(Zaehler);
        PanelAnzahl.Caption:='Anzahl Berechnungen: '+IntToStr(Zaehler);
        if Zaehler=1999 Then BitBtnStopClick(Sender);                           // Abbruch Timer
      end       Else

    If FiSi='C' Then                                                            // Collatz-Problem
      Begin
        If Odd(Zahl1) Then Zahl1:=(3*Zahl1)+1
                      Else Zahl1:=Zahl1 Div 2;

        ZeichenKette:=FormatFloat('###,###,###,##0',Zahl1);
        While Length(ZeichenKette)<>30 Do ZeichenKette:= ' '+ZeichenKette;
        For i:=1 To Length(Zeichenkette) Do If ZeichenKette[i]=',' Then ZeichenKette[i]:='.';
        ListBoxCP.Items.Add(ZeichenKette);

        Zaehler:=Succ(Zaehler);
        PanelAnzahl.Caption:='Anzahl Berechnungen: '+IntToStr(Zaehler);
        If Zahl1=1 Then  BitBtnStopClick(Sender);
      end       Else

      Begin                                                                     // Sieb des Eratosthenes
        If PrimZahlenFeld[Zaehler] Then
          Begin
            j:=Zaehler;
            repeat
              k:=j+Zaehler;                                                     // Formel
              j:=k;
              PrimZahlenFeld[j]:=False;

              PrimZahl:=2;                                                      // Sieb-Grid leeren zur Anzeige
              For Zeile:=0 To StringGridPrimZahlen.RowCount-1 Do
                For Spalte:=0 To StringGridPrimZahlen.ColCount-1 Do
                  Begin
                    If PrimZahlenFeld[PrimZahl]=False Then
                      StringGridPrimZahlen.Cells[Spalte,Zeile]:='';
                    Inc(PrimZahl);
                  End;
 //           ShowMessage('j / LetzteZahl: '+IntToStr(j)+' / '+IntToStr(LetzteZahl));
            until j>350;                                                        // LetzteZahl-1 ==> unverständlich!
          end;

        Inc(Zaehler);
        PanelAnzahl.Caption:='Anzahl Berechnungen: '+IntToStr(Zaehler);
        If (Zaehler*Zaehler)>LetzteZahl Then BitBtnStopClick(Sender);           // Abbruch Timer;
      end;

  If SignalEinAus Then                                                          // Blinken
    Begin
      SignalEinAus:=False;
      LabelSignal.Color:=clRed;
    end           Else
    Begin
      SignalEinAus:=True;
      LabelSignal.Color:=clLime;
    end;
end;

(*--------------------------- Stop -------------------------------------------*)

Procedure TFormFibonacciFolge.BitBtnStopClick(Sender: TObject);
begin
  Timer.Enabled:=False; BitBtnStop.Enabled:=False;                              // Timer aus
  LabelSignal.Enabled:=False;
end;

(*--------------------------- Berechnung Fibonacci-Folge ---------------------*)

procedure TFormFibonacciFolge.BitBtnBerechnungFibonacciClick(Sender: TObject);

begin
  FiSi:='F';                                                                    // Steuern Berechnung;
  Zahl1:=0; Zahl2:=1; Zaehler:=0;
  ButtonSignalResize(Sender); ListBoxZahl.Clear;                                // Start Timer

  ZeichenKette:=FormatFloat('###,###,###,##0',Zahl1);
  While Length(ZeichenKette)<>30 Do ZeichenKette:= ' '+ZeichenKette;
  ListBoxZahl.Items.Add(ZeichenKette);
  ZeichenKette:=FormatFloat('###,###,###,##0',Zahl2);
  While Length(ZeichenKette)<>30 Do ZeichenKette:= ' '+ZeichenKette;
  ListBoxZahl.Items.Add(ZeichenKette);
end;

(*--------------------------- Goldener Schnitt -------------------------------*)

procedure TFormFibonacciFolge.BitBtnGoldenerSchnittClick(Sender: TObject);
begin
  FiSi:='G';
  Zaehler:=0; a:=0; b:=0;
  ButtonSignalResize(Sender); ListBoxGS.Clear;
end;

(*--------------------------- Collatz-Problem --------------------------------*)

procedure TFormFibonacciFolge.BitBtnCollatzProblemClick(Sender: TObject);

var i: Integer;

begin
  ZeichenKette:=''; Zahl1:=0;
  For i:=1 to Length(EditCollatzProblem.Text) Do
    If (EditCollatzProblem.Text[i]>='0') And
       (EditCollatzProblem.Text[i]<='9') Then
      ZeichenKette:=ZeichenKette+EditCollatzProblem.Text[i];

  If Length(ZeichenKette)>0 Then Val(ZeichenKette,Zahl1,i);

  If (Length(ZeichenKette)=0) Or (Zahl1=0) Or (Zahl1>99999999999999999) Then
    Begin
      ShowMessage('Die Eingabe muss eine gueltige, natuerliche Zahl n sein!'+#13+
                  '( n = {1; 2; 3; ...} < 100.999.999.999.999.999 )');
      Exit;
    end;

  FiSi:='C'; Zaehler:=0;
//  Str(Zahl1,ZeichenKette); ShowMessage('Zahl eingegeben: '+ZeichenKette);
  ButtonSignalResize(Sender); ListBoxCP.Clear;

  ZeichenKette:=FormatFloat('###,###,###,##0',Zahl1);
  For i:=1 To Length(Zeichenkette) Do If ZeichenKette[i]=',' Then ZeichenKette[i]:='.';
  While Length(ZeichenKette)<>23 Do ZeichenKette:= ' '+ZeichenKette;
  ListBoxCP.Items.Add('==> '+ZeichenKette+' <==');
end;

(*--------------------------- Berechnung Primzahlen --------------------------*)

procedure TFormFibonacciFolge.BitBtnBerechnungPrimZahlenClick(Sender: TObject);

begin
  FiSi:='S'; Zaehler:=2;
  ButtonSignalResize(Sender);                                                   // Start Timer
end;

initialization
  {$I Unit1.lrs}
end.

